<?php
/* --------------------------------------------------------------
   OvistoCouponRepositoryInterface.inc.php 2018-01-29
   Gambio GmbH
   http://www.gambio.de
   Copyright (c) 2018 Gambio GmbH
   Released under the GNU General Public License (Version 2)
   [http://www.gnu.org/licenses/gpl-2.0.html]
   --------------------------------------------------------------
*/

/**
 * Interface OvistoCouponRepositoryInterface
 */
interface OvistoCouponRepositoryInterface
{
    /**
     * Gets a coupon by its ID.
     *
     * @param IdType $id
     *
     * @return OvistoCoupon
     */
    public function getCouponById(IdType $id);
    
    
    /**
     * Gets all available Ovisto coupons.
     *
     * @param IntType $limit
     * @param IntType $offset
     *
     * @return OvistoCouponCollection
     */
    public function getAllCoupons(IntType $limit, IntType $offset);
    
    
    /**
     * Gets the total number of available Ovisto coupons.
     *
     * @return int
     */
    public function getCouponQuantity();
}